package lab3;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.RandomAccessFile;
import java.io.Serializable;

public class ObjectRandomAccessFile extends RandomAccessFile {
    
    private final ByteArrayOutputStream bOut;
    private byte[] buf;
    
    public ObjectRandomAccessFile(String name, String mode) throws FileNotFoundException {
        super(name,mode);
        bOut = new ByteArrayOutputStream();
    }
    
    public int writeObject(Object obj) throws IOException {
        if (obj != null && obj instanceof Serializable) {
            ObjectOutputStream objOut = new ObjectOutputStream(bOut);
            objOut.writeObject(obj);
            int size = bOut.size();
            writeInt(size);
            write(bOut.toByteArray(),0,size);
            bOut.reset();
            return size+4;
        } else {
            return 0;
        }
    }
    
    public Object readObject() throws IOException, ClassNotFoundException {
        int size = readInt();
        if (buf == null || size > buf.length) {
            buf = new byte[size];
        }
        read(buf,0,size);
        ObjectInputStream objIn = new ObjectInputStream(new ByteArrayInputStream(buf,0,size));
        Object obj = objIn.readObject();
        objIn.close();
        return obj;
    }
    
    public void seekObject(int pos) throws IOException {
        if (pos >= 0) {
            seek(0);
            for(int i=0; i<pos; i++) {
                int size = readInt();
                skipBytes(size);
            }
        } else throw new IOException("Negative pos in seekObject.");
    }   
}
